$progress-width: 200px !default;
$progress-height: rhythm(1.5) !default;
$progress-margin: rhythm(.25) 0 !default;
$progress-padding: 0 !default;
$progress-bar-height: 4px !default;
$progress-bar-margin: 0 !default;
$progress-bar-padding: 0 !default;
$progress-radius: 4px !default;
$progress-border: 0 !default;
$progress-background: color('black', 'alpha', 10) !default;
$progress-value-background: color('black') !default;

$progress-message-spacing: rhythm(.5) !default;
$progress-message-color: map-get($text-colors, 'normal') !default;
$progress-message-font-size: map-get($font-sizes, 'normal') !default;
$progress-percentage-color: map-get($text-colors, 'normal') !default;
$progress-percentage-spacing: rhythm(.5) !default;
$progress-percentage-font-size: map-get($font-sizes, 'small') !default;

$progress-tiny-width: 25px !default;
$progress-tiny-height: rhythm(.25) !default;
$progress-tiny-margin: rhythm(.125) 0 !default;
$progress-tiny-percentage-font-size: map-get($font-sizes, 'tiny') !default;


.#{$namespace}-progress {
  position: relative;
  display: inline-block;
  width: $progress-width;
  height: $progress-height;
  margin: $progress-margin;
  padding: $progress-padding;


  // message
  &::after {
    @include ellipsis(80%);

    content: attr(aria-label);
    position: absolute;
    left: 0;
    bottom: $progress-message-spacing;
    color: $progress-message-color;
  }


  progress {
    appearance: none;

    position: absolute;
    left: 0;
    bottom: 0;
    width: 100%;
    height: $progress-bar-height;
    margin: $progress-bar-margin;
    padding: $progress-bar-padding;

    background: $progress-background;
    border: $progress-border;
    border-radius: $progress-radius;

    // percentage
    &::before {
      position: absolute;
      right: 0;
      bottom: $progress-percentage-spacing;
      font-size: $progress-percentage-font-size;
      color: $progress-percentage-color;
    }

    &[value] {
      &::-webkit-progress-bar {
        width: 100%;
        height: $progress-bar-height;
        background: $progress-background;
        border-radius: $progress-radius;
      }

      &::-webkit-progress-value {
        position: relative;
        width: auto;
        height: $progress-bar-height;
        background: $progress-value-background;
        border-radius: $progress-radius;
      }

      // percentage
      &::before {
        content: attr(value)'%';
      }
    }

    // no value specified
    &:not(value) {
      &::-webkit-progress-bar {
        background: $progress-background;
      }

      &::-webkit-progress-value {
        background: $progress-background;
      }

      &::before {
        content: '0%';
      }
    }
  }


  &--tiny {
    width: $progress-tiny-width;
    height: $progress-tiny-height;
    margin: $progress-tiny-margin;
    line-height: $base-line-height;

    &::after {
      display: none;
    }

    progress {
      &::before {
        top: 0;
        right: 0;
        left: 0;
        display: inline;
        text-align: right;
        vertical-align: top;
        font-size: $progress-tiny-percentage-font-size;
      }
    }
  }


  &--full {
    width: 100%;
  }
}
